%define		PYVER		2.6
%define		__python	python%{PYVER}
%define		PVER		%(echo %{PYVER} | awk -F. '{print$1$2}')
%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

%define _default_patch_fuzz 2 \n\n
%define client_only        0
# Disable all server side drivers if client only build requested
%if %{client_only}
%define server_drivers     0
%else
%define server_drivers     1
%endif

# Now set the defaults for all the important features, independent
# of any particular OS

# First the daemon itself
%define with_libvirtd      1
%define with_avahi         1

# Then the hypervisor drivers that run on local host
%define with_qemu          1
%define with_openvz        0
%define with_lxc           1
%define with_vbox          1
%define with_uml           1
# XXX this shouldn't be here, but it mistakenly links into libvirtd
%define with_one           0

# Then the hypervisor drivers that talk a native remote protocol
%define with_phyp          0
%define with_esx           0

# Then the secondary host drivers
%define with_network       1
%define with_storage_fs    1
%define with_storage_lvm   1
%define with_storage_iscsi 0
%define with_storage_disk  1
%define with_storage_mpath 1
%define with_numactl       1

# A few optional bits off by default, we enable later
%define with_polkit        0
%define with_capng         0
%define with_netcf         0
%define with_udev          1
%define with_hal           1
%define with_yajl          1

# Non-server/HV driver defaults which are always enabled
%define with_python        1
%define with_sasl          1

%define qemu_user  qemu
%define qemu_group  qemu

Distribution:	CCux
Packager:	Christian Metzen <metzench@ccux-linux.de>

Summary: 	Library providing a simple API virtualization
Name: 		libvirt
Version: 	0.8.2
Release: 	1
BuildArch:	i686
License: 	LGPLv2+
Group: 		Development/Libraries
Source: 	http://libvirt.org/sources/libvirt-%{version}.tar.gz
Source201:	libvirtd.init
URL: 		http://libvirt.org/
BuildRequires: 	python26-devel
Requires: 	libvirt-client = %{version}-%{release}

# Used by many of the drivers, so turn it on whenever the
# daemon is present
%if %{with_libvirtd}
Requires: 	bridge-utils
%endif
%if %{with_network}
Requires: 	dnsmasq
Requires: 	iptables
%endif
# needed for device enumeration
%if %{with_hal}
Requires: 	hal
%endif
%if %{with_udev}
Requires: 	udev
%endif
%if %{with_polkit}
Requires: 	polkit >= 0.95
%endif
%if %{with_storage_fs}
# For mount/umount in FS driver
BuildRequires: 	util-linux
# For showmount in FS driver (netfs discovery)
BuildRequires: 	nfs-utils
Requires: 	nfs-utils
%endif
%if %{with_qemu}
Requires: 	qemu-img
# For image compression
Requires: 	gzip
Requires: 	bzip2
Requires: 	lzop
Requires: 	xz
%endif
%if %{with_storage_lvm}
# For LVM drivers
Requires: 	lvm2
%endif
%if %{with_storage_iscsi}
# For ISCSI driver
Requires: 	iscsi-initiator-utils
%endif
%if %{with_storage_disk}
# For disk driver
Requires: 	parted
%endif
%if %{with_storage_mpath}
# For multipath support
Requires: 	device-mapper
%endif
BuildRequires: 	libxml2-devel
#BuildRequires: 	xhtml1-dtds
BuildRequires: 	readline-devel
BuildRequires: 	ncurses-devel
BuildRequires: 	gettext
BuildRequires: 	gnutls-devel
%if %{with_hal}
BuildRequires: 	hal-devel
%endif
%if %{with_udev}
BuildRequires: 	libudev-devel >= 145
BuildRequires: 	libpciaccess-devel >= 0.10.9
%endif
%if %{with_yajl}
BuildRequires: 	yajl-devel
%endif
%if %{with_avahi}
BuildRequires: 	avahi-devel
%endif
%if %{with_network}
BuildRequires: 	dnsmasq
%endif
BuildRequires: 	bridge-utils
%if %{with_sasl}
BuildRequires: 	cyrus-sasl-devel >= 2.1.23-2
BuildRequires:	cyrus-sasl-sql >= 2.1.23-2
BuildRequires:	cyrus-sasl >= 2.1.23-2
%endif
%if %{with_polkit}
BuildRequires: 	polkit >= 0.95
%endif
%if %{with_storage_fs}
# For mount/umount in FS driver
BuildRequires: 	util-linux
%endif
%if %{with_qemu}
BuildRequires: 	qemu-img
%endif
%if %{with_storage_lvm}
# For LVM drivers
BuildRequires: 	lvm2
%endif
%if %{with_storage_iscsi}
# For ISCSI driver
BuildRequires: 	iscsi-initiator-utils
%endif
%if %{with_storage_disk}
# For disk driver
BuildRequires: 	parted-devel
BuildRequires: 	e2fsprogs-devel
%endif
%if %{with_storage_mpath}
# For Multipath support
BuildRequires: 	device-mapper-devel
%endif
%if %{with_numactl}
# For QEMU/LXC numa info
BuildRequires: 	numactl-devel
%endif
%if %{with_capng}
BuildRequires: 	libcap-ng-devel >= 0.5.0
%endif
%if %{with_netcf}
BuildRequires: 	netcf-devel >= 0.1.4
%endif
BuildRequires: gawk libgcrypt-devel libgpg-error-devel libtasn1-devel libsmbios-devel lxc-devel
BuildRequires: zlib-devel

%description
Libvirt is a C toolkit to interact with the virtualization capabilities
of recent versions of Linux (and other OSes). The main package includes
the libvirtd server exporting the virtualization support.

%package client
Summary: 	Client side library and utilities of the libvirt library
Group: 		Development/Libraries
Requires: 	readline
Requires: 	ncurses
# So remote clients can access libvirt over SSH tunnel
# (client invokes 'nc' against the UNIX socket on the server)
Requires: 	nc
%if %{with_sasl}
Requires: 	cyrus-sasl-sql >= 2.1.23-2
%endif

%description client
Shared libraries and client binaries needed to access to the
virtualization capabilities of recent versions of Linux (and other OSes).

%package devel
Summary: 	Libraries, includes, etc. to compile with the libvirt library
Group: 		Development/Libraries
Requires: 	libvirt-client = %{version}-%{release}
Requires: 	pkgconfig

%description devel
Includes and documentations for the C library providing an API to use
the virtualization capabilities of recent versions of Linux (and other OSes).

%if %{with_python}
%package python
Summary: 	Python bindings for the libvirt library
Group: 		Development/Libraries
Requires: 	libvirt-client = %{version}-%{release}

%description python
The libvirt-python package contains a module that permits applications
written in the Python programming language to use the interface
supplied by the libvirt library to use the virtualization capabilities
of recent versions of Linux (and other OSes).
%endif

%prep
%setup -q

%build
%if ! %{with_qemu}
%define _without_qemu --without-qemu
%endif

%if ! %{with_openvz}
%define _without_openvz --without-openvz
%endif

%if ! %{with_lxc}
%define _without_lxc --without-lxc
%endif

%if ! %{with_vbox}
%define _without_vbox --without-vbox
%endif

%if ! %{with_sasl}
%define _without_sasl --without-sasl
%endif

%if ! %{with_avahi}
%define _without_avahi --without-avahi
%endif

%if ! %{with_phyp}
%define _without_phyp --without-phyp
%endif

%if ! %{with_esx}
%define _without_esx --without-esx
%endif

%if ! %{with_polkit}
%define _without_polkit --without-polkit
%endif

%if ! %{with_python}
%define _without_python --without-python
%endif

%if ! %{with_libvirtd}
%define _without_libvirtd --without-libvirtd
%endif

%if ! %{with_uml}
%define _without_uml --without-uml
%endif

%if ! %{with_one}
%define _without_one --without-one
%endif

%if ! %{with_network}
%define _without_network --without-network
%endif

%if ! %{with_storage_fs}
%define _without_storage_fs --without-storage-fs
%endif

%if ! %{with_storage_lvm}
%define _without_storage_lvm --without-storage-lvm
%endif

%if ! %{with_storage_iscsi}
%define _without_storage_iscsi --without-storage-iscsi
%endif

%if ! %{with_storage_disk}
%define _without_storage_disk --without-storage-disk
%endif

%if ! %{with_storage_mpath}
%define _without_storage_mpath --without-storage-mpath
%endif

%if ! %{with_numactl}
%define _without_numactl --without-numactl
%endif

%if ! %{with_capng}
%define _without_capng --without-capng
%endif

%if ! %{with_netcf}
%define _without_netcf --without-netcf
%endif

%if ! %{with_hal}
%define _without_hal --without-hal
%endif

%if ! %{with_udev}
%define _without_udev --without-udev
%endif

%if ! %{with_yajl}
%define _without_yajl --without-yajl
%endif

FIX=$(find -type f -name "*" -exec grep -I -l -e "^#!/usr/bin/python" -e "^#!/usr/bin/env python" -e "^#! /usr/bin/python" -e "^#! /usr/bin/env python" "{}" \; )
for i in $FIX; do
    sed -i "s,^#!/usr/bin/python,#!/usr/bin/python%{PYVER}," $i
    sed -i "s,^#! /usr/bin/python,#!/usr/bin/python%{PYVER}," $i
    sed -i "s,^#!/usr/bin/env python,#!/usr/bin/env python%{PYVER}," $i
    sed -i "s,^#! /usr/bin/env python,#!/usr/bin/env python%{PYVER}," $i
done


%configure --without-xen \
           %{?_without_qemu} \
           %{?_without_openvz} \
           %{?_without_lxc} \
           %{?_without_vbox} \
           %{?_without_sasl} \
           %{?_without_avahi} \
           %{?_without_polkit} \
           %{?_without_python} \
           %{?_without_libvirtd} \
           %{?_without_uml} \
           %{?_without_one} \
           %{?_without_phyp} \
           %{?_without_esx} \
           %{?_without_network} \
           %{?_with_rhel5_api} \
           %{?_without_storage_fs} \
           %{?_without_storage_lvm} \
           %{?_without_storage_iscsi} \
           %{?_without_storage_disk} \
           %{?_without_storage_mpath} \
           %{?_without_numactl} \
           %{?_without_capng} \
           %{?_without_netcf} \
           --without-selinux \
           %{?_without_hal} \
           %{?_without_udev} \
           %{?_without_yajl} \
           --with-qemu-user=%{qemu_user} \
           --with-qemu-group=%{qemu_group} \
           --with-init-script=redhat \
           --with-remote-pid-file=%{_localstatedir}/run/libvirtd.pid \
           PYTHON=/usr/bin/python%{PYVER} IPTABLES_PATH=/usr/sbin/iptables
make %{?_smp_mflags}
gzip -9 ChangeLog

%install
rm -fr %{buildroot}

%makeinstall
for i in domain-events/events-c dominfo domsuspend hellolibvirt python
do
  (cd examples/$i ; make clean ; rm -rf .deps .libs Makefile Makefile.in)
done
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/python*/site-packages/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/python*/site-packages/*.a

%if %{with_network}
# We don't want to install /etc/libvirt/qemu/networks in the main %files list
# because if the admin wants to delete the default network completely, we don't
# want to end up re-incarnating it on every RPM upgrade.
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/libvirt/networks/
cp $RPM_BUILD_ROOT%{_sysconfdir}/libvirt/qemu/networks/default.xml \
   $RPM_BUILD_ROOT%{_datadir}/libvirt/networks/default.xml
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/libvirt/qemu/networks/default.xml
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/libvirt/qemu/networks/autostart/default.xml
# Strip auto-generated UUID - we need it generated per-install
sed -i -e "/<uuid>/d" $RPM_BUILD_ROOT%{_datadir}/libvirt/networks/default.xml
%else
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/libvirt/qemu/networks/default.xml
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/libvirt/qemu/networks/autostart/default.xml
%endif
%if ! %{with_qemu}
rm -f $RPM_BUILD_ROOT%{_datadir}/augeas/lenses/libvirtd_qemu.aug
rm -f $RPM_BUILD_ROOT%{_datadir}/augeas/lenses/tests/test_libvirtd_qemu.aug
%endif
%find_lang %{name}

%if ! %{with_lxc}
rm -f $RPM_BUILD_ROOT%{_datadir}/augeas/lenses/libvirtd_lxc.aug
rm -f $RPM_BUILD_ROOT%{_datadir}/augeas/lenses/tests/test_libvirtd_lxc.aug
%endif

%if ! %{with_python}
rm -rf $RPM_BUILD_ROOT%{_datadir}/doc/libvirt-python-%{version}
%endif

%if %{client_only}
rm -rf $RPM_BUILD_ROOT%{_datadir}/doc/libvirt-%{version}
%endif

%if ! %{with_qemu}
rm -rf $RPM_BUILD_ROOT%{_sysconfdir}/libvirt/qemu.conf
%endif
%if ! %{with_lxc}
rm -rf $RPM_BUILD_ROOT%{_sysconfdir}/libvirt/lxc.conf
%endif

%if %{with_libvirtd}
chmod 0644 $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/libvirtd
%endif

install -m 755 %{SOURCE201} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/libvirtd

#set CCux specific defaults
sed -i "s,^#LIBVIRTD_CONFIG=/etc/libvirt/libvirtd.conf,LIBVIRTD_CONFIG=/etc/libvirt/libvirtd.conf," $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/libvirtd
sed -i "s,^#unix_sock_rw_perms = \"0770\",unix_sock_rw_perms = \"0777\"," $RPM_BUILD_ROOT%{_sysconfdir}/libvirt/libvirtd.conf
sed -i "s,^#unix_sock_group = \"libvirt\",unix_sock_group = \"qemu\"," $RPM_BUILD_ROOT%{_sysconfdir}/libvirt/libvirtd.conf

%clean
rm -fr %{buildroot}

%post
%if %{with_libvirtd}
%if %{with_network}
# We want to install the default network for initial RPM installs
# or on the first upgrade from a non-network aware libvirt only.
# We check this by looking to see if the daemon is already installed
/sbin/chkconfig --list libvirtd 1>/dev/null 2>&1
if [ $? != 0 -a ! -f %{_sysconfdir}/libvirt/qemu/networks/default.xml ]
then
    UUID=`/usr/bin/uuidgen`
    sed -e "s,</name>,</name>\n  <uuid>$UUID</uuid>," \
         < %{_datadir}/libvirt/networks/default.xml \
         > %{_sysconfdir}/libvirt/qemu/networks/default.xml
    ln -s ../default.xml %{_sysconfdir}/libvirt/qemu/networks/autostart/default.xml
fi
%endif

/sbin/chkconfig --add libvirtd
if [ "$1" -ge "1" ]; then
	/etc/init.d/libvirtd restart > /dev/null 2>&1
fi
%endif

%preun
%if %{with_libvirtd}
if [ $1 = 0 ]; then
 %{_sysconfdir}/init.d/libvirtd  stop 1>/dev/null 2>&1
    /sbin/chkconfig --del libvirtd
fi
%endif

%post client -p /sbin/ldconfig

%postun client -p /sbin/ldconfig

%if %{with_libvirtd}
%files
%defattr(-, root, root)
%doc AUTHORS ChangeLog.gz NEWS README COPYING.LIB TODO
%dir %attr(0700, root, root) %{_sysconfdir}/libvirt/
%if %{with_network}
%dir %attr(0700, root, root) %{_sysconfdir}/libvirt/qemu/
%dir %attr(0700, root, root) %{_sysconfdir}/libvirt/qemu/networks/
%dir %attr(0700, root, root) %{_sysconfdir}/libvirt/qemu/networks/autostart
%endif
%{_sysconfdir}/rc.d/init.d/libvirtd
%config(noreplace) %{_sysconfdir}/sysconfig/libvirtd
%config(noreplace) %{_sysconfdir}/libvirt/libvirtd.conf
#%config(noreplace) %{_sysconfdir}/logrotate.d/libvirtd

%{_sysconfdir}/libvirt/nwfilter/allow-arp.xml
%{_sysconfdir}/libvirt/nwfilter/allow-dhcp-server.xml
%{_sysconfdir}/libvirt/nwfilter/allow-dhcp.xml
%{_sysconfdir}/libvirt/nwfilter/allow-incoming-ipv4.xml
%{_sysconfdir}/libvirt/nwfilter/allow-ipv4.xml
%{_sysconfdir}/libvirt/nwfilter/clean-traffic.xml
%{_sysconfdir}/libvirt/nwfilter/no-arp-spoofing.xml
%{_sysconfdir}/libvirt/nwfilter/no-ip-multicast.xml
%{_sysconfdir}/libvirt/nwfilter/no-ip-spoofing.xml
%{_sysconfdir}/libvirt/nwfilter/no-mac-broadcast.xml
%{_sysconfdir}/libvirt/nwfilter/no-mac-spoofing.xml
%{_sysconfdir}/libvirt/nwfilter/no-other-l2-traffic.xml
%{_sysconfdir}/libvirt/nwfilter/no-other-rarp-traffic.xml
%{_sysconfdir}/libvirt/nwfilter/qemu-announce-self-rarp.xml
%{_sysconfdir}/libvirt/nwfilter/qemu-announce-self.xml
%{_sysconfdir}/logrotate.d/libvirtd.lxc
%{_sysconfdir}/logrotate.d/libvirtd.qemu
%{_sysconfdir}/logrotate.d/libvirtd.uml
%{_sysconfdir}/rc.d/init.d/libvirt-guests
%{_sysconfdir}/sysconfig/libvirt-guests
%{_datadir}/libvirt/schemas/domainsnapshot.rng
%{_datadir}/libvirt/schemas/nwfilter.rng

%dir %attr(0700, root, root) %{_localstatedir}/log/libvirt/qemu/
%dir %attr(0700, root, root) %{_localstatedir}/log/libvirt/lxc/
%dir %attr(0700, root, root) %{_localstatedir}/log/libvirt/uml/
%if %{with_qemu}
%config(noreplace) %{_sysconfdir}/libvirt/qemu.conf
%endif
%if %{with_lxc}
%config(noreplace) %{_sysconfdir}/libvirt/lxc.conf
%endif
%dir %{_datadir}/libvirt/
%if %{with_network}
%dir %{_datadir}/libvirt/networks/
%{_datadir}/libvirt/networks/default.xml
%endif
%dir %{_localstatedir}/run/libvirt/
%dir %{_localstatedir}/lib/libvirt/
%dir %attr(0711, root, root) %{_localstatedir}/lib/libvirt/images/
%dir %attr(0711, root, root) %{_localstatedir}/lib/libvirt/boot/
%dir %attr(0700, root, root) %{_localstatedir}/cache/libvirt/
%if %{with_qemu}
%dir %attr(0700, root, root) %{_localstatedir}/run/libvirt/qemu/
%dir %attr(0700, %{qemu_user}, %{qemu_group}) %{_localstatedir}/lib/libvirt/qemu/
%dir %attr(0700, %{qemu_user}, %{qemu_group}) %{_localstatedir}/cache/libvirt/qemu/
%endif
%if %{with_lxc}
%dir %{_localstatedir}/run/libvirt/lxc/
%dir %attr(0700, root, root) %{_localstatedir}/lib/libvirt/lxc/
%endif
%if %{with_uml}
%dir %{_localstatedir}/run/libvirt/uml/
%dir %attr(0700, root, root) %{_localstatedir}/lib/libvirt/uml/
%endif
%if %{with_network}
%dir %{_localstatedir}/run/libvirt/network/
%dir %attr(0700, root, root) %{_localstatedir}/lib/libvirt/network/
%endif
%if %{with_qemu}
%{_datadir}/augeas/lenses/libvirtd_qemu.aug
%{_datadir}/augeas/lenses/tests/test_libvirtd_qemu.aug
%endif
%if %{with_lxc}
%{_datadir}/augeas/lenses/libvirtd_lxc.aug
%{_datadir}/augeas/lenses/tests/test_libvirtd_lxc.aug
%endif
%{_datadir}/augeas/lenses/libvirtd.aug
%{_datadir}/augeas/lenses/tests/test_libvirtd.aug
%if %{with_polkit}
%{_datadir}/polkit-1/actions/org.libvirt.unix.policy
%endif
%dir %attr(0700, root, root) %{_localstatedir}/log/libvirt/
%if %{with_lxc}
%attr(0755, root, root) %{_libexecdir}/libvirt_lxc
%endif
%attr(0755, root, root) %{_libexecdir}/libvirt_parthelper
%attr(0755, root, root) %{_sbindir}/libvirtd
%doc docs/*.xml
%endif

%files client -f %{name}.lang
%defattr(-, root, root)
%doc AUTHORS ChangeLog.gz NEWS README COPYING.LIB TODO
%{_mandir}/man1/virsh.1*
%{_mandir}/man1/virt-xml-validate.1*
%{_mandir}/man1/virt-pki-validate.1*
%{_bindir}/virsh
%{_bindir}/virt-xml-validate
%{_bindir}/virt-pki-validate
%{_libdir}/lib*.so.*
%dir %{_datadir}/libvirt/
%dir %{_datadir}/libvirt/schemas/
%{_datadir}/libvirt/schemas/domain.rng
%{_datadir}/libvirt/schemas/network.rng
%{_datadir}/libvirt/schemas/storagepool.rng
%{_datadir}/libvirt/schemas/storagevol.rng
%{_datadir}/libvirt/schemas/nodedev.rng
%{_datadir}/libvirt/schemas/capability.rng
%{_datadir}/libvirt/schemas/interface.rng
%{_datadir}/libvirt/schemas/secret.rng
%{_datadir}/libvirt/schemas/storageencryption.rng
%{_datadir}/libvirt/cpu_map.xml
%if %{with_sasl}
%config(noreplace) %{_sysconfdir}/sasl2/libvirt.conf
%endif

%files devel
%defattr(-, root, root)
%{_libdir}/lib*.so
%dir %{_includedir}/libvirt
%{_includedir}/libvirt/*.h
%{_libdir}/pkgconfig/libvirt.pc
%dir %{_datadir}/gtk-doc/html/libvirt/
%doc %{_datadir}/gtk-doc/html/libvirt/*.devhelp
%doc %{_datadir}/gtk-doc/html/libvirt/*.html
%doc %{_datadir}/gtk-doc/html/libvirt/*.png
%doc %{_datadir}/gtk-doc/html/libvirt/*.css
%doc docs/*.html docs/html docs/*.gif
%doc docs/libvirt-api.xml
%doc examples/hellolibvirt
%doc examples/domain-events/events-c
%doc examples/dominfo
%doc examples/domsuspend
%doc examples/xml

%if %{with_python}
%files python
%defattr(-, root, root)
%doc AUTHORS NEWS README COPYING.LIB
%{_libdir}/python*/site-packages/libvirt.py*
%{_libdir}/python*/site-packages/libvirtmod*
%doc python/tests/*.py
%doc python/TODO
%doc examples/python
%doc examples/domain-events/events-python
%endif

%changelog
* Thu Jul 22 2010 Karsten Brockmann <arcam@ccux-linux.de> 0.8.2-1
- Version update
* Wed Mar 31 2010 Karsten Brockmann <arcam@ccux-linux.de> 0.7.7-1
- Version update
* Mon Jan 25 2010 Christian Metzen <metzench@ccux-linux.de> 0.7.5-3
- modify default config, users in qemu group are able to manage through virsh or virt-manager
* Sat Jan 23 2010 Christian Metzen <metzench@ccux-linux.de> 0.7.5-2
- fix iptables location
- fix init script
* Sat Jan 23 2010 Christian Metzen <metzench@ccux-linux.de> 0.7.5-1
- Initial CCux package release
